// Copyright (c) 2015 Noriaki Mitsunaga
// You can use this software under GPL v2 or later.

const int A = 2;
const int B = 3;
bool AB = false;
const int PULSE_W = 22;

unsigned int ccwPulse1 = 4000;//3500;      // 逆回転パルス幅1
unsigned int ccwPulse2 = 12000;     // 逆回転パルス幅2（値の上限は16383）

void ccwP(){                          // 逆回転パルス発生
  digitalWrite(13,HIGH);              // LED flash
  if (AB == true) {
    digitalWrite(A, HIGH);            // coil drive foward
    delayMicroseconds(ccwPulse1);     // wait 
    digitalWrite(A, LOW);             // coil drive end

    digitalWrite(B, HIGH);           // coil drive revers
    delayMicroseconds(ccwPulse2);     // wait 
    digitalWrite(B, LOW);            // coil drive end
  }
  else {
    digitalWrite(B, HIGH);           // coil drive revers
    delayMicroseconds(ccwPulse1);     // wait 
    digitalWrite(B, LOW);            // coil drive end

    digitalWrite(A, HIGH);            // coil drive foward
    delayMicroseconds(ccwPulse2);     // wait 
    digitalWrite(A, LOW);             // coil drive end
  }
  AB = ! AB;
  digitalWrite(13,LOW);               // LED flash end
}

void pulse() {
  if (AB) {
    digitalWrite(A, HIGH);
    delay(PULSE_W);
    digitalWrite(A, LOW);
    delay(50-PULSE_W);
  } else {
    digitalWrite(B, HIGH);
    delay(PULSE_W);
    digitalWrite(B, LOW);
    delay(50-PULSE_W);
  }
  AB = !AB;
}

void setup() {         
  digitalWrite(A, LOW);
  digitalWrite(B, LOW);
  pinMode(A, OUTPUT);
  pinMode(B, OUTPUT);
  
  // 磁石の向きを整える
  pulse();
  delay(500);
  ccwP();
  delay(3000);
}

void loop() 
{
  // 10s, 10pulses
  for (int i=0; i<10; i++) {
    //pulse();
    ccwP();
    delay(950);
  }
  
  // 10s( 5s + 4s + 1s), 20 pulses
//  delay(5000);
  for (int i=0; i<10; i++) {
    pulse();
    delay(350);
  }
  for (int i=0; i<10; i++) {
    pulse();
    delay(50);
  }
  
  delay(1000); // 1s, 0 pulse  
  T337();      // 4s, 13 pulses
//  delay(8000); // 8s, 0 pulse

//  delay(10000); // 10s 0 pulse

#if 0
// 17s, 17pulses
  for (int i=0; i<17; i++) {
    pulse();
    delay(950);
  }
#endif
}

void T337()
{
  pulse();
  delay(250);
  pulse();
  delay(250);
  pulse();
  delay(550);
  // ここまで 900ms

  pulse();
  delay(250);
  pulse();
  delay(250);
  pulse();
  delay(550);
  // +900ms

  pulse();
  delay(250);
  pulse();
  delay(250);
  pulse();
  delay(250);
  pulse();
  delay(250);
  pulse();
  delay(250);
  pulse();
  delay(250);
  pulse();
  delay(350);
  // +2200ms
  // 合計 4000ms;
}
